Index: trunk/include/FlairCore/SharedMem.h
===================================================================
--- trunk/include/FlairCore/SharedMem.h	(revision 61)
+++ trunk/include/FlairCore/SharedMem.h	(revision 62)
@@ -27,5 +27,5 @@
 *
 * Shared memory is identified by its name so it can be accessed
-* by another processus using its name.
+* by another process using its name.
 */
 
@@ -65,9 +65,9 @@
   * \param size buffer size
   */
-  void Read(char *buf, size_t size) const;
+  bool Read(char *buf, size_t size, Time nsTimeout=TIME_INFINITE) const;
 
 
   /*!
-  * \brief This function should be called when reader starts (in case of a SharedMem of type producerConsumer)
+  * \brief This function should be called when reader is ready (in case of a SharedMem of type producerConsumer)
   */
    void ReaderReady();
Index: trunk/include/FlairCore/Vector3DSpinBox.h
===================================================================
--- trunk/include/FlairCore/Vector3DSpinBox.h	(revision 61)
+++ trunk/include/FlairCore/Vector3DSpinBox.h	(revision 62)
@@ -68,5 +68,5 @@
   void XmlEvent(void);
 
-  core::Vector3Df box_value;
+  core::Vector3D<double> box_value;
 };
 
Index: trunk/include/FlairFilter/AhrsComplementaryFilter.h
===================================================================
--- trunk/include/FlairFilter/AhrsComplementaryFilter.h	(revision 61)
+++ trunk/include/FlairFilter/AhrsComplementaryFilter.h	(revision 62)
@@ -24,4 +24,5 @@
     namespace gui {
         class DoubleSpinBox;
+        class Vector3DSpinBox;
     }
 }
@@ -69,4 +70,6 @@
             gui::DoubleSpinBox *ka[3];
             gui::DoubleSpinBox *kb[3];
+            gui::DoubleSpinBox *km[3];
+            gui::Vector3DSpinBox *magRef;
     };
 } // end namespace filter
Index: trunk/include/FlairFilter/PidThrust.h
===================================================================
--- trunk/include/FlairFilter/PidThrust.h	(revision 61)
+++ trunk/include/FlairFilter/PidThrust.h	(revision 62)
@@ -55,10 +55,4 @@
 
   /*!
-  * \brief Reset integral and offset to 0
-  *
-  */
-  void Reset(void);
-
-  /*!
   * \brief Reset integral to 0
   *
@@ -67,14 +61,15 @@
 
   /*!
-  * \brief Reset offset to 0
+  * \brief Set offset to a specified value
   *
+  * \param value desired value
   */
-  void ResetOffset(void);
-
+  void SetOffset(float value);
+  
   /*!
   * \brief Set offset to specified value in ground station
   *
   */
-  void SetOffset(void);
+  void SetDefaultOffset(void);
 
   /*!
Index: trunk/include/FlairFilter/TrajectoryGenerator1D.h
===================================================================
--- trunk/include/FlairFilter/TrajectoryGenerator1D.h	(revision 61)
+++ trunk/include/FlairFilter/TrajectoryGenerator1D.h	(revision 62)
@@ -127,4 +127,5 @@
   * \brief Position
   *
+  * \return the actual position
   */
   float Position(void) const;
@@ -133,6 +134,16 @@
   * \brief Speed
   *
+  * \return the actual speed
   */
   float Speed(void) const;
+  
+  /*!
+  * \brief Get percentage of completion
+  * 
+  * Value is between 0 and 100.
+  *
+  * \return the percentage of completion (in position)
+  */
+  float GetPercentageOfCompletion(void) const;
 
   /*!
Index: trunk/include/FlairMeta/UavStateMachine.h
===================================================================
--- trunk/include/FlairMeta/UavStateMachine.h	(revision 61)
+++ trunk/include/FlairMeta/UavStateMachine.h	(revision 62)
@@ -228,4 +228,10 @@
   const sensor::TargetController *GetJoystick(void) const;
   MetaDualShock3 *joy;
+  
+  filter::NestedSat *GetURoll(void);
+  filter::NestedSat *GetUPitch(void);
+  filter::Pid *GetUYaw(void);
+  filter::PidThrust *GetUZ(void);
+  filter::TrajectoryGenerator1D *GetAltitudeTrajectory(void);
 
   gui::Tab *setupLawTab, *graphLawTab;
Index: trunk/include/FlairSensorActuator/Imu.h
===================================================================
--- trunk/include/FlairSensorActuator/Imu.h	(revision 61)
+++ trunk/include/FlairSensorActuator/Imu.h	(revision 62)
@@ -53,6 +53,7 @@
   *
   * \param name name
+  * \param needRotation true will enable post rotation in GCS. Post rotation must be applied manually in reimplemented code
   */
-  Imu(std::string name);
+  Imu(std::string name,bool needRotation=true);
 
   /*!
Index: trunk/include/FlairSensorActuator/SimuGps.h
===================================================================
--- trunk/include/FlairSensorActuator/SimuGps.h	(revision 61)
+++ trunk/include/FlairSensorActuator/SimuGps.h	(revision 62)
@@ -99,5 +99,5 @@
   core::SharedMem *shmem;
   gui::SpinBox *dataRate,*fixQuality,*numberOfSatellites;
-  gui::DoubleSpinBox *latitudeRef,*longitudeRef,*altitudeRef;
+  gui::DoubleSpinBox *latitudeRef,*longitudeRef,*altitudeRef,*magneticDeclination;
 };
 } // end namespace sensor
